'From Cuis 5.0 [latest update: #4256] on 11 July 2020 at 2:40:31 pm'!

!VectorEngineAbstract methodsFor: 'accessing' stamp: 'jmv 7/11/2020 11:22:33'!
boundingRectOfCurrentMorphAfterDraw
	"In targetForm coordinates.
	Only valid _after_ drawing currentMorph."
"ojo. si es un rect, quizas habria que sumar 1 al corner..."
	^morphBoundsLeft @ morphBoundsTop corner: morphBoundsRight @ morphBoundsBottom! !


!VectorEngineSubPixel methodsFor: 'private' stamp: 'jmv 7/11/2020 11:27:48'!
finishPath
	"Blend stroke and/or fill over background, according to the just computed pen alphas (distance from pixel to center of stroke)"
	
	"If we are doing a fill, and caller forgot to close the trajectory, then do it anyway."
	fillColor notNil ifTrue: [
		(pathFirstX = pathCurrentX and: [ pathFirstY = pathCurrentY ]) ifFalse: [
			"This is actually an error condition. If we are asked to fill, then the path should be closed.
			This is a workaround. If width > 0.0, we'll be adding a visible edge to the path."
			self basicClosePath ]].

	blendLeft _ (blendLeft - auxStrokeWidthDilatedHalf - subPixelDelta) truncated +1.
	blendTop _ (blendTop - auxStrokeWidthDilatedHalf) truncated +1.
	blendRight _ (blendRight + auxStrokeWidthDilatedHalf + subPixelDelta) truncated +1. "Make room not just for updated mask, but also edges (hence, +1)"
	blendBottom _ (blendBottom + auxStrokeWidthDilatedHalf) truncated.

	morphBoundsLeft _ morphBoundsLeft min: blendLeft.
	morphBoundsTop _ morphBoundsTop min: blendTop.
	morphBoundsRight _ morphBoundsRight max: blendRight.
	morphBoundsBottom _ morphBoundsBottom max: blendBottom.

	blendLeft< clipLeft ifTrue: [ blendLeft _ clipLeft ].
	blendTop < clipTop ifTrue: [ blendTop _ clipTop ].
	blendRight > clipRight ifTrue: [ blendRight _ clipRight ].
	blendBottom > clipBottom ifTrue: [ blendBottom _ clipBottom ].

	(blendRight >= blendLeft and: [ blendBottom >= blendTop ]) ifTrue: [
		fillColor notNil ifTrue: [
			strokeColor notNil
				ifTrue: [ self blendStrokeAndFill ]
				ifFalse: [ self blendFillOnly ]]
			ifFalse: [
				self blendStrokeOnly ]].

	pathFirstX _ 0.0.
	pathFirstY _ 0.0.
	pathCurrentX _ 0.0.
	pathCurrentY _ 0.0.
	previousCallX _ 0.0.
	previousCallY _ 0.0.
	previousCallControlX _ previousCallX.
	previousCallControlY _ previousCallY.! !


!VectorEngineWholePixel methodsFor: 'private' stamp: 'jmv 7/11/2020 11:28:01'!
finishPath
	"Blend stroke and/or fill over background, according to the just computed pen alphas (distance from pixel to center of stroke)"
	
	"If we are doing a fill, and caller forgot to close the trajectory, then do it anyway."
	fillColor notNil ifTrue: [
		(pathFirstX = pathCurrentX and: [ pathFirstY = pathCurrentY ]) ifFalse: [
			"This is actually an error condition. If we are asked to fill, then the path should be closed.
			This is a workaround. If width > 0.0, we'll be adding a visible edge to the path."
			self basicClosePath ]].

	blendLeft _ (blendLeft - auxStrokeWidthDilatedHalf) truncated +1.
	blendTop _ (blendTop - auxStrokeWidthDilatedHalf) truncated +1.
	blendRight _ (blendRight + auxStrokeWidthDilatedHalf) truncated +1. "Make room not just for updated mask, but also edges (hence, +1)"
	blendBottom _ (blendBottom + auxStrokeWidthDilatedHalf) truncated.

	morphBoundsLeft _ morphBoundsLeft min: blendLeft.
	morphBoundsTop _ morphBoundsTop min: blendTop.
	morphBoundsRight _ morphBoundsRight max: blendRight.
	morphBoundsBottom _ morphBoundsBottom max: blendBottom.

	blendLeft< clipLeft ifTrue: [ blendLeft _ clipLeft ].
	blendTop < clipTop ifTrue: [ blendTop _ clipTop ].
	blendRight > clipRight ifTrue: [ blendRight _ clipRight ].
	blendBottom > clipBottom ifTrue: [ blendBottom _ clipBottom ].

	(blendRight >= blendLeft and: [ blendBottom >= blendTop ]) ifTrue: [
		fillColor notNil ifTrue: [
			strokeColor notNil
				ifTrue: [ self blendStrokeAndFill ]
				ifFalse: [ self blendFillOnly ]]
			ifFalse: [
				self blendStrokeOnly ]].

	pathFirstX _ 0.0.
	pathFirstY _ 0.0.
	pathCurrentX _ 0.0.
	pathCurrentY _ 0.0.
	previousCallX _ 0.0.
	previousCallY _ 0.0.
	previousCallControlX _ previousCallX.
	previousCallControlY _ previousCallY.! !

