'From Cuis 5.0 [latest update: #4260] on 12 July 2020 at 1:02:36 pm'!

!RectangleLikeMorph methodsFor: 'geometry' stamp: 'jmv 7/12/2020 13:02:20'!
lastBoundsInWorld: aRectangle
	"For this herarchy, we know that #redrawNeeded always report all affected pixels.
	There is no need to ask for yet another #redrawNeeded"

	self lastBoundsInWorld ~= aRectangle ifTrue: [
		self setProperty: #lastBoundsInWorld toValue: aRectangle ]! !

!RectangleLikeMorph methodsFor: 'updating' stamp: 'jmv 7/12/2020 13:00:53'!
redrawNeeded
	"Report that the area occupied by this morph should be redrawn.
	For this hierarchy, #morphBoundsInWorld is guaranteed to include all affected pixels.
	Therefore, #lastBoundsInWorld: doesn't need to trigger another #redrawNeeded."

	self invalidateDisplayRect: self morphBoundsInWorld from: nil.
	"Expensive in many cases..."
	self submorphsDrawingOutsideReverseDo: [ :m | m redrawNeeded ]! !


!RectangleLikeMorph reorganize!
('accessing' color color:)
('initialization' defaultColor initialize)
('drawing' addPossiblyUncoveredAreasIn:to: drawOn:)
('geometry' lastBoundsInWorld: morphBoundsInWorld morphExtent morphExtent: morphExtentInWorld: morphFullBoundsInWorld morphHeight morphHeight: morphPosition:extent: morphWidth morphWidth: privateExtent:)
('geometry testing' isOrthoRectangularMorph requiresVectorCanvas)
('layout-properties' layoutSpec:)
('updating' redrawNeeded)
!

