'From Cuis 5.0 [latest update: #4263] on 12 July 2020 at 5:51:35 pm'!

!HandMorph methodsFor: 'geometry' stamp: 'jmv 7/12/2020 15:46:31'!
morphFullBoundsInWorld
	| fullBounds |
	fullBounds _ self morphBoundsInWorld.
	self submorphsDo: [ :m |
		fullBounds _ fullBounds merge: m morphFullBoundsInWorld ].
	^fullBounds! !


!HandMorph methodsFor: 'grabbing/dropping' stamp: 'jmv 7/11/2020 18:11:37'!
grabMorph: aMorph moveUnderHand: moveUnderHand
	"Grab the given morph (i.e., add it to this hand and remove it from its current owner).
	If moveUnderHand is requested or it seems neccesary anyway, move the grabbed morph under the hand."

	| grabbed delta |
	"#aboutToGrab: and #aboutToBeGrabbedBy: might mess wildly with our morphs.
	If we need it, prepare delta before that happens"
	moveUnderHand ifFalse: [
		delta _ aMorph morphPositionInWorld - self morphPositionInWorld ].
	self releaseMouseFocus.	"Break focus"
	grabbed _ aMorph.
	aMorph owner ifNotNil: [ :o |
		grabbed _ o aboutToGrab: aMorph ].
	grabbed ifNil: [ ^ self ].
	grabbed _ grabbed aboutToBeGrabbedBy: self.
	grabbed ifNil: [ ^ self ].
	(moveUnderHand or: [ (grabbed == aMorph) not ])
		ifTrue: [ delta _ (grabbed lastBoundsInWorldOrBogus extent // 2) negated ].
	^ self
		grabMorph: grabbed
		delta: delta! !

