'From Cuis 5.0 [latest update: #4267] on 14 July 2020 at 10:32:40 pm'!

!GeometryTransformation methodsFor: 'as yet unclassified' stamp: 'jmv 7/14/2020 22:28:30'!
zrotatedBy: radians
	"rotate the receiver by radians angle.
	Answer the modified object. In this implementation this requires the creation of a new, more general instance.
	Senders should always use the returned object, but not assume it is a new one: it could also be the receiver itself,
	as if the receiver is already a AffineTransformation."
	
	^(AffineTransformation new withRotation: self radians + radians scale: self scale) withTranslation: self translation! !


!Morph methodsFor: 'geometry' stamp: 'jmv 7/14/2020 21:45:52'!
rotateBy: radians
	"Change the scale of this morph. Argument is an angle."
	self redrawNeeded.
	location _ location zrotatedBy: radians.
	self redrawNeeded.
	owner ifNotNil: [ owner someSubmorphPositionOrExtentChanged ]! !

