'From Cuis 5.0 [latest update: #4256] on 11 July 2020 at 2:45:06 pm'!
!classDefinition: #HybridCanvas category: #'VectorGraphics-Kernel'!
BitBltCanvas subclass: #HybridCanvas
	instanceVariableNames: 'vectorCanvas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VectorGraphics-Kernel'!

!HybridCanvas commentStamp: '<historical>' prior: 0!
A HybridCanvas works as a BitBltCanvas until faced with a situation that BitBlitCanvas can't handle. At that point, the vectorCanvas takes command.

self runningWorld setCanvas: (HybridCanvas onForm: Display).
self runningWorld canvas class!


!HybridCanvas methodsFor: 'initialization' stamp: 'jmv 7/11/2020 00:07:15'!
world: aPasteUpMorph
	super world: aPasteUpMorph.
	vectorCanvas world: aPasteUpMorph! !

!HybridCanvas methodsFor: 'private' stamp: 'jmv 7/11/2020 09:55:52'!
canvasToUse

	currentMorph requiresVectorCanvas ifTrue: [
		^ vectorCanvas ].
	^self.! !

!HybridCanvas methodsFor: 'private' stamp: 'jmv 7/11/2020 10:55:59'!
clippingMorph: aMorph
	super clippingMorph: aMorph.
	vectorCanvas clippingMorph: aMorph! !

!HybridCanvas methodsFor: 'private' stamp: 'jmv 7/9/2020 16:06:02'!
resetEngine
	super resetEngine.
	vectorCanvas _ VectorCanvas onForm: form.! !

!HybridCanvas methodsFor: 'private' stamp: 'jmv 7/11/2020 10:55:26'!
setClipRect: aRectangle
	super setClipRect: aRectangle.
	vectorCanvas setClipRect: aRectangle! !

!HybridCanvas methodsFor: 'morphic' stamp: 'jmv 7/9/2020 16:36:45'!
into: aMorph
	super into: aMorph.
	vectorCanvas into: aMorph! !

!HybridCanvas methodsFor: 'morphic' stamp: 'jmv 7/9/2020 16:36:59'!
outOfMorph
	super outOfMorph.
	vectorCanvas outOfMorph! !

