'From Cuis 5.0 [latest update: #4257] on 11 July 2020 at 2:52:16 pm'!
!classDefinition: #EllipseMorph2 category: #'VectorGraphics-Experiments'!
Morph subclass: #EllipseMorph2
	instanceVariableNames: 'rx ry borderWidth borderColor color'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VectorGraphics-Experiments'!

!EllipseMorph2 commentStamp: 'jmv 7/10/2020 17:45:40' prior: 0!
self runningWorld setCanvas: (HybridCanvas onForm: Display).
self runningWorld canvas class.

Hide taskbar.

EllipseMorph2 new openInWorld.
EllipseMorph2 allInstancesDo: [ :a | a delete ]!


!EllipseMorph2 methodsFor: 'drawing' stamp: 'jmv 7/9/2020 16:52:04'!
drawOn: aCanvas 

	aCanvas ellipseCenterX: 0 y: 0 rx: rx ry: ry borderWidth: borderWidth borderColor: borderColor fillColor: color! !

!EllipseMorph2 methodsFor: 'initialization' stamp: 'jmv 7/11/2020 09:56:31'!
initialize
	super initialize.
	rx _ 100.
	ry _ 30.
	color _ Color yellow.
	borderWidth _ 5.
	borderColor _ Color green! !

!EllipseMorph2 methodsFor: 'as yet unclassified' stamp: 'jmv 7/9/2020 18:18:49'!
clipsLastSubmorph
"hacer algo con esto?"
	^super clipsLastSubmorph! !

!EllipseMorph2 methodsFor: 'as yet unclassified' stamp: 'jmv 7/10/2020 17:39:54'!
imageForm: depth
	self flag: #puff.
	'--------------' print.
	thisContext printStack: 10.
	^super imageForm: depth! !

!EllipseMorph2 methodsFor: 'as yet unclassified' stamp: 'jmv 7/10/2020 17:39:58'!
imageForm: extent depth: depth
	self flag: #puff.
	'--------------' print.
	thisContext printStack: 10.
	^super imageForm: extent depth: depth! !

!EllipseMorph2 methodsFor: 'as yet unclassified' stamp: 'jmv 7/10/2020 17:40:01'!
morphBounds
	self flag: #puff.
	'--------------' print.
	thisContext printStack: 10.
	^super morphBounds! !

!EllipseMorph2 methodsFor: 'as yet unclassified' stamp: 'jmv 7/10/2020 17:53:01'!
morphBoundsInWorld
"Podemos hacer que el canvas/engine, despues de dibujarnos, nos ponga nuestros bounds.
Esto significa que un Morph no puede ser dibujado en 2 lugares distintos.
O podramos recibir el root en este caso, y solo tomar los bounds si corresponde.
Esto parece mejor. Sino, imageForm o lo que sea ya rompe todo....
Podemos hacerlo en #fullDraw:, preguntando algo... No s qu. Quizs el canvas debera estar marcado como canvas de world, o algo asi...  Una truchada para experimentar puede ser ver si el form es Display. La cosa de validar si es el canvas del world se rompe con este HybridCanvas...

Bueno. Ahora.
Guardar bounds o fullbounds? el canvas solo registra bounds."
"La maquinaria en el canvas puede hacerse de todos modos. En BitBlt, sera la porqueria que hacemos ahora. En el hibrido y el vector sera algo mejor.
O sea, todos estos metodos cambiarian en toda la jerarquia."
"
Este esta usando #morphLocalBounds
"	self flag: #puff.

	'--------------' print.
	thisContext printStack: 10.

^self lastBoundsInWorld! !

!EllipseMorph2 methodsFor: 'as yet unclassified' stamp: 'jmv 7/11/2020 10:46:23'!
morphContainsPoint: aLocalPoint
	self flag: #puff.
^ (-10 @ -10 extent: 100@100) containsPoint: aLocalPoint! !

!EllipseMorph2 methodsFor: 'as yet unclassified' stamp: 'jmv 7/11/2020 10:46:41'!
morphExtent
	self flag: #puff.
	"
	'--------------' print.
	thisContext printStack: 10.
	"
	^10@10*50! !

!EllipseMorph2 methodsFor: 'as yet unclassified' stamp: 'jmv 7/10/2020 17:40:13'!
morphExtentInWorld
	self flag: #puff.
	'--------------' print.
	thisContext printStack: 10.
	^super morphExtentInWorld! !

!EllipseMorph2 methodsFor: 'as yet unclassified' stamp: 'jmv 7/10/2020 17:40:16'!
morphHeight
	self flag: #puff.
	'--------------' print.
	thisContext printStack: 10.
	^super morphHeight! !

!EllipseMorph2 methodsFor: 'as yet unclassified' stamp: 'jmv 7/11/2020 09:58:57'!
morphLocalBounds
"
Probablemente pueda sacarse de Morph y pasarlo a los DisplayRectMorph o como se llamen
"

"si. es por aca. Pero mas especificament #morphBoundsInWorld
displayBoundsInWorldOf:
En realidad, los dos.
"
"
	'--------------' print.
	thisContext printStack: 10.
"

^super morphLocalBounds outsetBy: 40

"
ver senders de
#puff
"! !

!EllipseMorph2 methodsFor: 'as yet unclassified' stamp: 'jmv 7/10/2020 17:40:25'!
morphWidth
	self flag: #puff.
	'--------------' print.
	thisContext printStack: 10.
	^super morphWidth! !


!EllipseMorph2 class methodsFor: 'new-morph participation' stamp: 'jmv 7/9/2020 16:50:50'!
categoryInNewMorphMenu
	^ 'Basic'! !

