'From Cuis 5.0 [latest update: #4267] on 14 July 2020 at 10:32:43 pm'!
!classDefinition: #EllipseMorph3 category: #'VectorGraphics-Experiments'!
Morph subclass: #EllipseMorph3
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VectorGraphics-Experiments'!

!EllipseMorph3 commentStamp: '<historical>' prior: 0!
"
self runningWorld setCanvas: (HybridCanvas onForm: Display).
"
a _ EllipseMorph2 new openInWorld.
b _ EllipseMorph3 new.
c _ EllipseMorph4 new.
a addMorph: b.
b morphPosition: 100@0.
a addMorph: c.
c morphPosition: -100@0.
"
EllipseMorph2 allInstancesDo: [ :a | a delete ].
"!

!classDefinition: #EllipseMorph4 category: #'VectorGraphics-Experiments'!
Morph subclass: #EllipseMorph4
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VectorGraphics-Experiments'!


!EllipseMorph2 methodsFor: 'stepping' stamp: 'jmv 7/14/2020 21:37:32'!
step! !

!EllipseMorph2 methodsFor: 'stepping' stamp: 'jmv 7/14/2020 22:06:54'!
stepAt: millisecondSinceLast
	"See comment at #wantsSteps"
	self rotateBy: Float twoPi / 60! !

!EllipseMorph2 methodsFor: 'stepping' stamp: 'jmv 7/14/2020 21:36:57'!
wantsSteps
	^true! !

!EllipseMorph2 methodsFor: 'geometry' stamp: 'jmv 7/14/2020 22:18:25'!
morphExtentInWorld: newExtent
	"world coordinates
	Ignored by morphs that are not resizeable"
	self scaleBy: newExtent magnitude / (100*location scale)! !


!EllipseMorph3 methodsFor: 'drawing' stamp: 'jmv 7/14/2020 22:07:53'!
drawOn: aCanvas 

	aCanvas ellipseCenterX: 0 y: 0 rx: 5 ry: 30 borderWidth: 3 borderColor: Color red fillColor: Color orange! !


!EllipseMorph3 class methodsFor: 'new-morph participation' stamp: 'jmv 7/14/2020 21:52:15'!
categoryInNewMorphMenu
	^ 'Basic'! !


!EllipseMorph4 methodsFor: 'stepping' stamp: 'jmv 7/14/2020 22:07:07'!
stepAt: millisecondSinceLast
	"See comment at #wantsSteps"
	self rotateBy: Float twoPi / -60! !

!EllipseMorph4 methodsFor: 'stepping' stamp: 'jmv 7/14/2020 21:59:44'!
stepTime
	"Answer the desired time between steps in milliseconds. This default implementation requests that the 'step' method be called once every second."

	^ 100! !

!EllipseMorph4 methodsFor: 'stepping' stamp: 'jmv 7/14/2020 21:57:54'!
wantsSteps
	^true! !

!EllipseMorph4 methodsFor: 'drawing' stamp: 'jmv 7/14/2020 22:06:29'!
drawOn: aCanvas 

	aCanvas ellipseCenterX: 0 y: 30 rx: 4 ry: 30 borderWidth: 3 borderColor: Color black fillColor: Color veryLightGray! !


!EllipseMorph4 class methodsFor: 'new-morph participation' stamp: 'jmv 7/14/2020 21:56:44'!
categoryInNewMorphMenu
	^ 'Basic'! !


!EllipseMorph2 methodsFor: 'drawing' stamp: 'jmv 7/14/2020 22:06:01'!
drawOn: aCanvas 

	aCanvas ellipseCenterX: 0 y: 0 rx: 100 ry: 6 borderWidth: 6 borderColor: Color gray fillColor: Color black! !

!methodRemoval: EllipseMorph3 #stepAt: stamp: 'jmv 7/14/2020 22:31:38'!
EllipseMorph3 removeSelector: #stepAt:!
!methodRemoval: EllipseMorph3 #wantsSteps stamp: 'jmv 7/14/2020 22:31:44'!
EllipseMorph3 removeSelector: #wantsSteps!

!EllipseMorph3 reorganize!
('drawing' drawOn:)
!

